# coding: latin-1

"""Infos ber die Instanz.

Aufruf: info
"""
from operator import itemgetter
from ebkus.config import config
from ebkus.app.ebapi import AkteList, FallList, today, DokumentList, MitarbeiterList, CodeList
from ebkus.app import Request
from ebkus.db.sql import execute
from ebkus.app.ebapi import register_get



def get_info(sections, q):
    """sections: list of config sections, e.g. ['instance', 'apache', 'ebkus']"""
    info = 'Stellen: {}\n'.format(', '.join(
            ["{} ({})".format(st['name'], st['code']) 
             for st in CodeList(where="kat_code = 'stzei'")]))
    info += 'Akten: {}\n'.format(execute("select count(*) from akte")[0][0])
    info += 'Flle: {}\n'.format(execute("select count(*) from fall")[0][0])
    info += 'Mitarbeiter: {}\n'.format(execute("select count(*) from mitarbeiter")[0][0])
    info += 'Beratungskontakte: {}\n'.format(execute("select count(*) from beratungskontakt")[0][0])
    info += 'Dokumente: {}\n'.format(execute("select count(*) from dokument")[0][0])
    info += 'Gruppen: {}\n'.format(execute("select count(*) from gruppe")[0][0])
    info += 'Straenkatalog: {}\n'.format(execute("select count(*) from strkatalog")[0][0])
    info += '\nKonfiguration:\n'
    last_section = None
    for section, name, value, db_value in get_config():
        if section != last_section:
            last_section = section
            info += "[{section}]\n".format(**locals())
        if section[0] in sections and (q is None or q.lower() in name.lower()):
            if db_value is not None and value != db_value:
                db = " !! {db_value}\n"
            else:
                db = "\n"
            info += ("{name:>50}: {value}" + db).format(**locals())
    return info


def get_config():
    res = []
    for kv in config.iter():
        section = kv.section
        if section == 'instance' and kv.fachlich:
            section = 'fachlich'
        name = kv.name
        value = kv.value
        db_value = None
        v_db = register_get(kv.name)
        #print 'CONFIG', v_db, kv.value
        if v_db != None:
            if kv.is_boolean():
                db_value = (v_db == 'true')
            elif kv.is_int():
                db_value = int(v_db)
            else:
                db_value = v_db
        res.append((section, name, value, db_value))
    res.sort()
    return res
class info(Request.Request):
    def checkAuth(self):
        # info ist nicht zugriffsgeschtzt
        pass

    def processForm(self, REQUEST, RESPONSE):
        q = self.form.get('q')
        config = self.form.get('config')
        if config == 'all':
            sections = ('a', 'e', 'f', 'i', 'o')
        else:
            sections = config.split(',') if config else []
            sections = [s[0] for s in sections]
            for s in sections:
                assert s in ('a', 'e', 'f', 'i', 'o'), 'Unknown config section'
        self.RESPONSE.setHeader('content-type', 'text/plain')
        #self.RESPONSE.setHeader('content-disposition', 'attachment; filename=%s' % file)
        self.RESPONSE.setBody(get_info(sections, q))

def main():
    print get_info()


if __name__ == '__main__':
    main()

